const { __ } = wp.i18n;
import { TabPanel, DateTimePicker } from "@wordpress/components";

const onSelect = (tabName) => {};

const DatesTabPanel = (props) => {
  const validLicense = true;
  let validLicenseClass = props.validLicense ? "" : "disabled-section";
  let desktop = "";
  let tablet = "";
  let mobile = "";
  let options_role = "";
  let widget_options = { ...props.widgetopts_get_settings };
  let days = [
    __("Monday"),
    __("Tuesday"),
    __("Wednesday"),
    __("Thursday"),
    __("Friday"),
    __("Saturday"),
    __("Sunday"),
  ];
  let months = [
    __("January"),
    __("February"),
    __("March"),
    __("April"),
    __("May"),
    __("June"),
    __("July"),
    __("August"),
    __("September"),
    __("October"),
    __("November"),
    __("December"),
  ];
  let args = [];
  let checked = "";
  let options_dates = "";
  let annual = true;

  const change_date_format = (_dateString) => {
    let new_date = "";
    if (typeof _dateString === "string" || _dateString instanceof String) {
      if (_dateString.trim() != "") {
        let _parseDate = Date.parse(_dateString);
        let _dates = new Date(_parseDate);

        let _m =
          (_dates.getMonth() < 9 ? "0" : "") +
          (_dates.getMonth() + 1).toString();
        let _d =
          (_dates.getDate() < 10 ? "0" : "") + _dates.getDate().toString();
        let _y = _dates.getFullYear();
        new_date = `${_y}-${_m}-${_d}`;
      }
    }

    return new_date;
  };

  let to =
    props.extended_widget_opts["dates"] != undefined
      ? change_date_format(props.extended_widget_opts["dates"]["to"])
      : "";

  let from =
    props.extended_widget_opts["dates"] != undefined
      ? change_date_format(props.extended_widget_opts["dates"]["from"])
      : "";

  const handleInputChange = (event, key1, key2) => {
    let _attribute = { ...props.extended_widget_opts };
    if (
      _attribute[key1] == undefined ||
      (_attribute[key1] != undefined && _attribute[key1].length == 0)
    ) {
      _attribute[key1] = {};
    }

    if (key1 == "dates" && (key2 == "from" || key2 == "to")) {
      if (event.target.value.trim() != "") {
        let _dates = new Date(event.target.value);
        let _m = months[_dates.getMonth()];

        let _d = _dates.getDate();
        let _y = _dates.getFullYear();
        _attribute[key1][key2] = `${_m} ${_d}, ${_y}`;
      } else {
        _attribute[key1][key2] = "";
      }
    } else {
      _attribute[key1][key2] = event.target.value;
    }

    props.onUpdateDynamicAttribute(_attribute, props.widgetId);
  };

  const handleInputChangeCheckbox = (event, key1, key2) => {
    let _attribute = { ...props.extended_widget_opts };
    if (
      _attribute[key1] == undefined ||
      (_attribute[key1] != undefined && _attribute[key1].length == 0)
    ) {
      _attribute[key1] = {};
    }

    if (event.target.checked) {
      _attribute[key1][key2] = 1;
    } else {
      delete _attribute[key1][key2];
    }

    props.onUpdateDynamicAttribute(_attribute, props.widgetId);
  };

  const checkLicense = (isLicenseValid) => {
    if (isLicenseValid) {
      return "";
    } else {
      return (
        <div className="extended-widget-opts-demo-warning">
          <p className="widgetopts-unlock-features">
            <span className="dashicons dashicons-lock"></span>
            <br />
            Your license has expired
            <br />
            or is not marked as active.
            <br />
            <a
              href="https://widget-options.com/account/"
              className="button-primary"
              target="_blank"
            >
              Learn More
            </a>
          </p>
        </div>
      );
    }
  };

  return (
    <div
      id={"extended-widget-opts-tab-" + props.widgetId + "-days"}
      className={
        "extended-widget-opts-tabcontent extended-widget-opts-tabcontent-days " +
        validLicenseClass
      }
      style={{ "margin-left": "16px" }}
    >
      {checkLicense(props.validLicense)}

      {widget_options["settings"]["dates"] != undefined &&
      widget_options["settings"]["dates"]["days"] != undefined &&
      "1" == widget_options["settings"]["dates"]["days"] ? (
        <div>
          <p style={{ "margin-top": "10px" }}>
            <strong>{__("Hide/Show")}</strong>
            <select
              class="widefat"
              name={"extended_widget_opts[days][options]"}
              onChange={(event) => handleInputChange(event, "days", "options")}
              value={
                props.extended_widget_opts["days"] != undefined
                  ? props.extended_widget_opts["days"]["options"]
                  : ""
              }
            >
              <option value="hide">{__("Hide on checked days")}</option>
              <option value="show">{__("Show on checked days")}</option>
            </select>
          </p>
          <table class="form-table">
            <tbody>
              <tr valign="top">
                <td scope="row">
                  <strong>{__("Days")}</strong>
                </td>
                <td>&nbsp;</td>
              </tr>
              {days.map(function (day, key) {
                if (
                  args["params"] != undefined &&
                  args["params"]["days"] != undefined
                ) {
                  if (args["params"]["days"][day.toLowerCase()] != undefined) {
                    checked = 'checked="checked"';
                  } else {
                    checked = "";
                  }
                } else {
                  checked = "";
                }

                return (
                  <tr valign="top">
                    <td scope="row">
                      <label
                        for={
                          "extended_widget_opts-" +
                          props.widgetId +
                          "-days-" +
                          day.toLowerCase()
                        }
                      >
                        {day}
                      </label>
                    </td>
                    <td>
                      <input
                        type="checkbox"
                        name={
                          "extended_widget_opts[days][" +
                          day.toLowerCase() +
                          "]"
                        }
                        id={
                          "extended_widget_opts-" +
                          props.widgetId +
                          "-days-" +
                          key
                        }
                        value="1"
                        onChange={(event) =>
                          handleInputChangeCheckbox(
                            event,
                            "days",
                            day.toLowerCase()
                          )
                        }
                        checked={
                          props.extended_widget_opts["days"] != undefined &&
                          props.extended_widget_opts["days"][
                            day.toLowerCase()
                          ] == 1
                            ? true
                            : false
                        }
                      />
                    </td>
                  </tr>
                );
              })}
            </tbody>
          </table>
          <br />
        </div>
      ) : (
        ""
      )}

      {widget_options["settings"]["dates"] != undefined &&
      widget_options["settings"]["dates"]["date_range"] != undefined &&
      "1" == widget_options["settings"]["dates"]["date_range"] ? (
        <div>
          <p>
            <strong>{__("Hide/Show")}</strong>
            <select
              class="widefat"
              name={"extended_widget_opts[dates][options]"}
              onChange={(event) => handleInputChange(event, "dates", "options")}
              value={
                props.extended_widget_opts["dates"] != undefined
                  ? props.extended_widget_opts["dates"]["options"]
                  : ""
              }
            >
              <option value="hide">{__("Hide on date range")}</option>
              <option value="show">{__("Show on date range")}</option>
            </select>
          </p>
          <table class="form-table">
            <tbody>
              <tr valign="top">
                <td scope="row">
                  <strong>{__("From: ")}</strong>
                </td>
                <td>
                  <input
                    type="date"
                    min={change_date_format(
                      new Date().toISOString().split("T")[0]
                    )}
                    pattern="\d{4}-\d{2}-\d{2}"
                    name={"extended_widget_opts[dates][from]"}
                    className="widefat extended-widget-opts-date-from"
                    onChange={(event) => {
                      event.preventDefault();
                      let date = new Date(event.target.value);

                      if (!isNaN(date) || event.target.value == "") {
                        handleInputChange(event, "dates", "from");
                      }
                    }}
                    defaultValue={from}
                  />
                </td>
              </tr>
              <tr valign="top">
                <td scope="row">
                  <strong>{__("To: ")}</strong>
                </td>
                <td>
                  <input
                    type="date"
                    min={change_date_format(
                      new Date().toISOString().split("T")[0]
                    )}
                    pattern="\d{4}-\d{2}-\d{2}"
                    name={"extended_widget_opts[dates][to]"}
                    className="widefat extended-widget-opts-date-to"
                    defaultValue={to}
                    onChange={(event) => {
                      event.preventDefault();
                      let date = new Date(event.target.value);

                      if (!isNaN(date) || event.target.value == "") {
                        handleInputChange(event, "dates", "to");
                      }
                    }}
                  />
                </td>
              </tr>
              <tr valign="top">
                <td colspan="2">
                  <input
                    type="checkbox"
                    id={
                      "extended_widget_opts-block-" + props.widgetId + "-annual"
                    }
                    name={"extended_widget_opts[dates][annual]"}
                    value="1"
                    onChange={(event) =>
                      handleInputChangeCheckbox(event, "dates", "annual")
                    }
                    checked={
                      props.extended_widget_opts["dates"] != undefined &&
                      props.extended_widget_opts["dates"]["annual"] == 1
                        ? true
                        : false
                    }
                  />
                  <label
                    for={
                      "extended_widget_opts-block-" + props.widgetId + "-annual"
                    }
                  >
                    Ignore Year parameter
                  </label>
                  <p>
                    Enabling this option makes the date range repeat yearly.
                    Only use on date ranges less than a year.
                  </p>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
      ) : (
        ""
      )}
    </div>
  );
};

export default DatesTabPanel;
